<?php

class HTTPRequest {
	private $host;
	private $path;
	private $port;
	private $scheme;
	private $postParams;
	private $cookie;
	private $leaveHeaders = false;
	
	function __construct($url,$postParams=false,$cookie=false) {
		extract(parse_url($url), EXTR_SKIP);
		$this->host = $host;
		$this->path = $path;
		$this->port = (isset($port) && !empty($port)) ? $port : 80;
		$this->scheme = $scheme;
		if($postParams !== false) $this->postParams = $postParams;
		if($cookie !== false) $this->cookie = $cookie;
	}
	
	public function leaveHeaders() {
		$this->leaveHeaders = true;
	}
	
	public function trimHeaders() {
		$this->leaveHeaders = false;
	}
	
	public function get() {
		$p = "GET {$this->path} HTTP/1.0\n";
		$p.= "Host: {$this->host}\n";
		$p.= "Connection: close\n\n";
		return $this->send($p);
	}
	
	public function post() {
		
	}
	
	public function head() {
		$this->leaveHeaders();
		$p = "HEAD {$this->path} HTTP/1.0\n";
		$p.= "Host: {$this->host}\n";
		$p.= "Connection: close\n\n";
		$headers = $this->send($p);
		$this->trimHeaders();
	}
	
	private function send($packet) {
		$socket = fsockopen(gethostbyname($this->host),$this->port);
		if(!$socket) return false;
		fputs($socket, $packet);
		$html='';
		while(!feof($socket)) $html.=fgets($socket);
		if(!$this->leaveHeaders) {
			$pos = strpos($html,"\r\n\r\n");
			$html = substr($html, $pos+4);
		}
		return $html;
	}
}