<?php
include 'includes/AjaxResponse.class.php';
include 'includes/HTTPRequest.class.php';
include 'includes/Fingerprint.class.php';

$resp = new AjaxResponse;
if(isset($_POST['url'])) {
	$fp = new Fingerprint($_POST['url']);
	if($fp->hasErrors()) {
		$resp->add(array('result' => array('error' => join($fp->getErrors()))));
		$resp->send();
		return;
	}
	$ver = $fp->getPossibleVersions();
	$vuln = getVulnerabilitiesForVersions($ver);
	$resp->add(array('result' => $vuln, 'version' => join(",",$ver)));
	$resp->send();
} else {
	$resp->add(array('result' => array('error' => 'Invalid data')));
	$this->send();
}

function getVulnerabilitiesForVersions($versions) {
	$vulns = array();
	$fp = fopen('vulns.csv', 'r');
	while(!feof($fp)) {
		$line = fgetcsv($fp, 2048, ';');
		$affectedVersions = explode(',', str_replace('|', ',', $line[4]));
		if(array_intersect($versions, $affectedVersions)) {
			$vulns[] = array('id' => $line[0], 'type' => $line[1], 'description' => $line[2], 'url' => $line[3], 'versions' => $line[4]);
		}
	}
	return $vulns;
}